package bookExamples.ch26Graphics.draw2d;

import bookExamples.ch26Graphics.draw2d.shapes.Line2d;


public class Ray2d {
    private Vec2d origin; // origin
    private Vec2d direction; // direction
    private int count;
    private double t = 0;
    private Drawable object;

    public Vec2d vecOnLine(double _t) {
        setT(_t);
        return getDirection().linearComb(getT(), getOrigin());
    }

    public Ray2d(Line2d l) {
        setCount(0);
        setOrigin(new Vec2d(l.getX1(), l.getY1()));
        setDirection(new Vec2d(l.getX2() - l.getX1(), l.getY2() - l.getY1()));
        getDirection().normalize();
    }

    public Ray2d(Vec2d _p, Vec2d _d) {
        setOrigin(new Vec2d(_p));
        setDirection(new Vec2d(_d));
    }

    public String toString() {
        return "Origin=" + getOrigin() + "\ndirection=" + getDirection();
    }

    public Vec2d getOrigin() {
        return origin;
    }

    public void setOrigin(Vec2d origin) {
        this.origin = origin;
    }

    public Vec2d getDirection() {
        return direction;
    }

    public void setDirection(Vec2d direction) {
        this.direction = direction;
    }

    public int getCount() {
        return count;
    }

    public void setCount(int count) {
        this.count = count;
    }

    public double getT() {
        return t;
    }

    public void setT(double t) {
        this.t = t;
    }

    public Drawable getObject() {
        return object;
    }

    public void setObject(Drawable object) {
        this.object = object;
    }
}

